"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .alert import Alert, AlertTypedDict
from .geojsongeometry import GeoJSONGeometry, GeoJSONGeometryTypedDict
from .jsonldcontext_union import JSONLdContextUnion, JSONLdContextUnionTypedDict
from enum import Enum
from nws_api_client.types import BaseModel, Nullable, UNSET_SENTINEL
import pydantic
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AlertGeoJSONType(str, Enum):
    FEATURE = "Feature"


class AlertGeoJSONTypedDict(TypedDict):
    r"""A GeoJSON feature. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: AlertGeoJSONType
    geometry: Nullable[GeoJSONGeometryTypedDict]
    r"""A GeoJSON geometry object. Please refer to IETF RFC 7946 for information on the GeoJSON format."""
    properties: AlertTypedDict
    r"""An object representing a public alert message.
    Unless otherwise noted, the fields in this object correspond to the National Weather Service CAP v1.2 specification, which extends the OASIS Common Alerting Protocol (CAP) v1.2 specification and USA Integrated Public Alert and Warning System (IPAWS) Profile v1.0. Refer to this documentation for more complete information.
    http://docs.oasis-open.org/emergency/cap/v1.2/CAP-v1.2-os.html http://docs.oasis-open.org/emergency/cap/v1.2/ipaws-profile/v1.0/cs01/cap-v1.2-ipaws-profile-cs01.html https://alerts.weather.gov/#technical-notes-v12

    """
    at_context: NotRequired[JSONLdContextUnionTypedDict]
    id: NotRequired[str]


class AlertGeoJSON(BaseModel):
    r"""A GeoJSON feature. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: AlertGeoJSONType

    geometry: Nullable[GeoJSONGeometry]
    r"""A GeoJSON geometry object. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    properties: Alert
    r"""An object representing a public alert message.
    Unless otherwise noted, the fields in this object correspond to the National Weather Service CAP v1.2 specification, which extends the OASIS Common Alerting Protocol (CAP) v1.2 specification and USA Integrated Public Alert and Warning System (IPAWS) Profile v1.0. Refer to this documentation for more complete information.
    http://docs.oasis-open.org/emergency/cap/v1.2/CAP-v1.2-os.html http://docs.oasis-open.org/emergency/cap/v1.2/ipaws-profile/v1.0/cs01/cap-v1.2-ipaws-profile-cs01.html https://alerts.weather.gov/#technical-notes-v12

    """

    at_context: Annotated[
        Optional[JSONLdContextUnion], pydantic.Field(alias="@context")
    ] = None

    id: Optional[str] = None

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["@context", "id"]
        nullable_fields = ["geometry"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
