"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from nws_api_client.types import BaseModel
from typing import Dict, List, Optional, Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


class AlertsActiveCountResponseBodyTypedDict(TypedDict):
    r"""A data structure showing the counts of active alerts broken down by various categories"""

    total: NotRequired[int]
    r"""The total number of active alerts"""
    land: NotRequired[int]
    r"""The total number of active alerts affecting land zones"""
    marine: NotRequired[int]
    r"""The total number of active alerts affecting marine zones"""
    regions: NotRequired[Dict[str, int]]
    r"""Active alerts by marine region"""
    areas: NotRequired[Dict[str, int]]
    r"""Active alerts by area (state/territory)"""
    zones: NotRequired[Dict[str, int]]
    r"""Active alerts by NWS public zone or county code"""


class AlertsActiveCountResponseBody(BaseModel):
    r"""A data structure showing the counts of active alerts broken down by various categories"""

    total: Optional[int] = None
    r"""The total number of active alerts"""

    land: Optional[int] = None
    r"""The total number of active alerts affecting land zones"""

    marine: Optional[int] = None
    r"""The total number of active alerts affecting marine zones"""

    regions: Optional[Dict[str, int]] = None
    r"""Active alerts by marine region"""

    areas: Optional[Dict[str, int]] = None
    r"""Active alerts by area (state/territory)"""

    zones: Optional[Dict[str, int]] = None
    r"""Active alerts by NWS public zone or county code"""


AlertsActiveCountResponseResultTypedDict = TypeAliasType(
    "AlertsActiveCountResponseResultTypedDict",
    Union[AlertsActiveCountResponseBodyTypedDict, ProblemDetailTypedDict],
)


AlertsActiveCountResponseResult = TypeAliasType(
    "AlertsActiveCountResponseResult",
    Union[AlertsActiveCountResponseBody, ProblemDetail],
)


class AlertsActiveCountResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: AlertsActiveCountResponseResultTypedDict


class AlertsActiveCountResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: AlertsActiveCountResponseResult
