"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .jsonldcontext_union import JSONLdContextUnion, JSONLdContextUnionTypedDict
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from nws_api_client.types import BaseModel
import pydantic
from typing import Dict, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class GlossaryTypedDict(TypedDict):
    term: NotRequired[str]
    r"""The term being defined"""
    definition: NotRequired[str]
    r"""A definition for the term"""


class Glossary(BaseModel):
    term: Optional[str] = None
    r"""The term being defined"""

    definition: Optional[str] = None
    r"""A definition for the term"""


class GlossaryResponseBodyTypedDict(TypedDict):
    r"""A set of glossary terms"""

    at_context: NotRequired[JSONLdContextUnionTypedDict]
    glossary: NotRequired[List[GlossaryTypedDict]]
    r"""A list of glossary terms"""


class GlossaryResponseBody(BaseModel):
    r"""A set of glossary terms"""

    at_context: Annotated[
        Optional[JSONLdContextUnion], pydantic.Field(alias="@context")
    ] = None

    glossary: Optional[List[Glossary]] = None
    r"""A list of glossary terms"""


GlossaryResponseResultTypedDict = TypeAliasType(
    "GlossaryResponseResultTypedDict",
    Union[GlossaryResponseBodyTypedDict, ProblemDetailTypedDict],
)


GlossaryResponseResult = TypeAliasType(
    "GlossaryResponseResult", Union[GlossaryResponseBody, ProblemDetail]
)


class GlossaryResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: GlossaryResponseResultTypedDict


class GlossaryResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: GlossaryResponseResult
