"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from .textproductcollection import TextProductCollection, TextProductCollectionTypedDict
from datetime import datetime
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, QueryParamMetadata
from typing import Dict, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class ProductsQueryRequestTypedDict(TypedDict):
    location: NotRequired[List[str]]
    r"""Location id"""
    start: NotRequired[datetime]
    r"""Start time"""
    end: NotRequired[datetime]
    r"""End time"""
    office: NotRequired[List[str]]
    r"""Issuing office"""
    wmoid: NotRequired[List[str]]
    r"""WMO id code"""
    type: NotRequired[List[str]]
    r"""Product code"""
    limit: NotRequired[int]
    r"""Limit"""


class ProductsQueryRequest(BaseModel):
    location: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Location id"""

    start: Annotated[
        Optional[datetime],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Start time"""

    end: Annotated[
        Optional[datetime],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""End time"""

    office: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Issuing office"""

    wmoid: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""WMO id code"""

    type: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=False)),
    ] = None
    r"""Product code"""

    limit: Annotated[
        Optional[int],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Limit"""


ProductsQueryResponseResultTypedDict = TypeAliasType(
    "ProductsQueryResponseResultTypedDict",
    Union[TextProductCollectionTypedDict, ProblemDetailTypedDict],
)


ProductsQueryResponseResult = TypeAliasType(
    "ProductsQueryResponseResult", Union[TextProductCollection, ProblemDetail]
)


class ProductsQueryResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: ProductsQueryResponseResultTypedDict


class ProductsQueryResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: ProductsQueryResponseResult
