"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .observation import Observation, ObservationTypedDict
from .observationgeojson import ObservationGeoJSON, ObservationGeoJSONTypedDict
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, PathParamMetadata, QueryParamMetadata
import pydantic
from typing import Dict, List, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


class StationObservationLatestRequestTypedDict(TypedDict):
    station_id: str
    r"""Observation station ID"""
    require_qc: NotRequired[bool]
    r"""Require QC"""


class StationObservationLatestRequest(BaseModel):
    station_id: Annotated[
        str,
        pydantic.Field(alias="stationId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Observation station ID"""

    require_qc: Annotated[
        Optional[bool],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Require QC"""


StationObservationLatestResponseResultTypedDict = TypeAliasType(
    "StationObservationLatestResponseResultTypedDict",
    Union[
        ObservationGeoJSONTypedDict, ProblemDetailTypedDict, ObservationTypedDict, bytes
    ],
)


StationObservationLatestResponseResult = TypeAliasType(
    "StationObservationLatestResponseResult",
    Union[ObservationGeoJSON, ProblemDetail, Observation, bytes],
)


class StationObservationLatestResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: StationObservationLatestResponseResultTypedDict


class StationObservationLatestResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: StationObservationLatestResponseResult
