"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .observation import Observation, ObservationTypedDict
from .observationgeojson import ObservationGeoJSON, ObservationGeoJSONTypedDict
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from datetime import datetime
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, PathParamMetadata
import pydantic
from typing import Dict, List, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


class StationObservationTimeRequestTypedDict(TypedDict):
    station_id: str
    r"""Observation station ID"""
    time: datetime
    r"""Timestamp of requested observation"""


class StationObservationTimeRequest(BaseModel):
    station_id: Annotated[
        str,
        pydantic.Field(alias="stationId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Observation station ID"""

    time: Annotated[
        datetime, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Timestamp of requested observation"""


StationObservationTimeResponseResultTypedDict = TypeAliasType(
    "StationObservationTimeResponseResultTypedDict",
    Union[
        ObservationGeoJSONTypedDict, ProblemDetailTypedDict, ObservationTypedDict, bytes
    ],
)


StationObservationTimeResponseResult = TypeAliasType(
    "StationObservationTimeResponseResult",
    Union[ObservationGeoJSON, ProblemDetail, Observation, bytes],
)


class StationObservationTimeResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: StationObservationTimeResponseResultTypedDict


class StationObservationTimeResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: StationObservationTimeResponseResult
