"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .problemdetail import ProblemDetail, ProblemDetailTypedDict
from datetime import date
from nws_api_client.types import BaseModel
from nws_api_client.utils import FieldMetadata, PathParamMetadata
import pydantic
from typing import Dict, List, Union
from typing_extensions import Annotated, TypeAliasType, TypedDict


class TafRequestTypedDict(TypedDict):
    station_id: str
    r"""Observation station ID"""
    date_: date
    r"""Date (YYYY-MM-DD format)"""
    time: str
    r"""Time (HHMM format). This time is always specified in UTC (Zulu) time."""


class TafRequest(BaseModel):
    station_id: Annotated[
        str,
        pydantic.Field(alias="stationId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Observation station ID"""

    date_: Annotated[
        date,
        pydantic.Field(alias="date"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Date (YYYY-MM-DD format)"""

    time: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Time (HHMM format). This time is always specified in UTC (Zulu) time."""


TafResponseResultTypedDict = TypeAliasType(
    "TafResponseResultTypedDict", Union[ProblemDetailTypedDict, bytes]
)


TafResponseResult = TypeAliasType("TafResponseResult", Union[ProblemDetail, bytes])


class TafResponseTypedDict(TypedDict):
    headers: Dict[str, List[str]]
    result: TafResponseResultTypedDict


class TafResponse(BaseModel):
    headers: Dict[str, List[str]]

    result: TafResponseResult
