"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .geojsongeometry import GeoJSONGeometry, GeoJSONGeometryTypedDict
from .jsonldcontext_union import JSONLdContextUnion, JSONLdContextUnionTypedDict
from .zoneforecast import ZoneForecast, ZoneForecastTypedDict
from enum import Enum
from nws_api_client.types import BaseModel, Nullable, UNSET_SENTINEL
import pydantic
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ZoneForecastGeoJSONType(str, Enum):
    FEATURE = "Feature"


class ZoneForecastGeoJSONTypedDict(TypedDict):
    r"""A GeoJSON feature. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: ZoneForecastGeoJSONType
    geometry: Nullable[GeoJSONGeometryTypedDict]
    r"""A GeoJSON geometry object. Please refer to IETF RFC 7946 for information on the GeoJSON format."""
    properties: ZoneForecastTypedDict
    r"""An object representing a zone area forecast."""
    at_context: NotRequired[JSONLdContextUnionTypedDict]
    id: NotRequired[str]


class ZoneForecastGeoJSON(BaseModel):
    r"""A GeoJSON feature. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    type: ZoneForecastGeoJSONType

    geometry: Nullable[GeoJSONGeometry]
    r"""A GeoJSON geometry object. Please refer to IETF RFC 7946 for information on the GeoJSON format."""

    properties: ZoneForecast
    r"""An object representing a zone area forecast."""

    at_context: Annotated[
        Optional[JSONLdContextUnion], pydantic.Field(alias="@context")
    ] = None

    id: Optional[str] = None

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["@context", "id"]
        nullable_fields = ["geometry"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
